Index: hostapd-2016-10-02/hostapd/main.c
===================================================================
--- hostapd-2016-10-02.orig/hostapd/main.c	2017-04-24 13:51:54.701046636 +0530
+++ hostapd-2016-10-02/hostapd/main.c	2017-04-24 13:52:40.140708849 +0530
@@ -37,6 +37,8 @@
 };
 
 static struct hapd_global global;
+static int daemonize = 0;
+static char *pid_file = NULL;
 
 
 #ifndef CONFIG_NO_HOSTAPD_LOGGER
@@ -143,6 +145,14 @@
 }
 #endif /* CONFIG_NO_HOSTAPD_LOGGER */
 
+static void hostapd_setup_complete_cb(void *ctx)
+{
+	if (daemonize && os_daemonize(pid_file)) {
+		perror("daemon");
+		return;
+	}
+	daemonize = 0;
+}
 
 /**
  * hostapd_driver_init - Preparate driver interface
@@ -161,6 +171,8 @@
 		return -1;
 	}
 
+	hapd->setup_complete_cb = hostapd_setup_complete_cb;
+
 	/* Initialize the driver interface */
 	if (!(b[0] | b[1] | b[2] | b[3] | b[4] | b[5]))
 		b = NULL;
@@ -401,8 +413,6 @@
 #endif /* CONFIG_NATIVE_WINDOWS */
 
 	eap_server_unregister_methods();
-
-	os_daemonize_terminate(pid_file);
 }
 
 
@@ -428,18 +438,6 @@
 	}
 #endif /* EAP_SERVER_TNC */
 
-	if (daemonize) {
-		if (os_daemonize(pid_file)) {
-			wpa_printf(MSG_ERROR, "daemon: %s", strerror(errno));
-			return -1;
-		}
-		if (eloop_sock_requeue()) {
-			wpa_printf(MSG_ERROR, "eloop_sock_requeue: %s",
-				   strerror(errno));
-			return -1;
-		}
-	}
-
 	eloop_run();
 
 	return 0;
@@ -635,8 +633,7 @@
 	struct hapd_interfaces interfaces;
 	int ret = 1;
 	size_t i, j;
-	int c, debug = 0, daemonize = 0;
-	char *pid_file = NULL;
+	int c, debug = 0;
 	const char *log_file = NULL;
 	const char *entropy_file = NULL;
 	char **bss_config = NULL, **tmp_bss;
